#include <iostream>
using namespace std;

int main() {
	const int dim{5};
	int array[dim];
	srand48(time(nullptr));

	for (int &value : array) {
		value = (int)(lrand48() % 100);
	}

	cout << "Array version\n";
	for (int i = 0; i < dim; i++) {
		cout << "array[" << i << "] = " << array[i] << endl;
	}
	cout << endl;

	cout << "Range-based for loop (since C++11)\n";
	for (int value : array) { // no index available
		cout << value << " ";
	}
	cout << endl;
	cout << endl;

	for (int &value : array) {
		cout << "array[" << &value - array << "] = " << value << endl;
	}
	cout << endl;

	cout << "Pointer version\n";
	for (int i = 0; i < dim; i++) {
		cout << "array[" << i << "] = " << *(array + i) << endl;
	}
	cout << endl;

	cout << "Another pointer version\n";
	for (int *pa = array; pa < array + dim; pa++) {
		cout << "array[" << pa - array << "] = " << *pa << endl;
	}

	return EXIT_SUCCESS;
}

