#include <iostream>
using namespace std;

constexpr int rows{3}, columns{4};
void set(int[][columns], int, int);
void print(int[][columns], int, int);
void print(const int*, int, int, int);

int main() {
	int array_2d[rows][columns];
	set (array_2d, rows, columns);

	print (array_2d, rows, columns);
	print (array_2d, 2, 3);
	print ((int*)array_2d, columns, rows, columns);
	print ((int*)array_2d, columns, 2, 3);

	return EXIT_SUCCESS;
}

void set(int array_2d[][columns], int nr, int nc) {
	for (int i = 0; i < nr; i++) {
		for (int j = 0; j < nc; j++) {
			array_2d[i][j] = columns * i + j;
		}
	}
}

void print(int array_2d[][columns], int nr, int nc) {
	for (int i = 0; i < nr; i++) {
		for (int j = 0; j < nc; j++) {
			cout << array_2d[i][j] << "\t";
		}
		cout << endl;
	}
	cout << endl;
}

// cols_defined has to be equal to number of columns from array definition
// Used for generic functions (taking any 2D array as a parameter)
void print(const int *ptr, int cols_defined, int nr, int nc) {
	for (int i = 0; i < nr; i++) {
		for (int j = 0; j < nc; j++) {
			cout << *(ptr + cols_defined * i + j) << "\t";
		}
		cout << endl;
	}
	cout << endl;
}

