#include <iostream>
#include <iomanip>
#include <cmath>
using namespace std;

void tabulate(double(*f)(double), double, double, double, const string&);
double my_function(double x) { return 1 / (1 + x*x); }

int main() {

	tabulate(sin, 0.0, M_PI, M_PI/10, "sin");
	tabulate(exp, 0.0, 1.0, 0.1, "exp");
	tabulate(my_function, 0.0, 1.0, 0.1, "my_function");

	return EXIT_SUCCESS;
}

void tabulate(double (*f)(double), double lower, double upper, double step, const string& name) {
    constexpr double eps {1e-10};
	cout << name << ":" << endl;
	cout << "-------------------" << endl;
	cout.setf(ios::fixed, ios::floatfield);
	cout << setprecision(4);
	for (double x = lower; x < upper-eps; x += step) {
		cout << setw(6) << x << setw(10) << f(x) << endl;
	}
	cout << setw(6) << upper << setw(10) << f(upper) << endl;
	cout << endl;
}

