#include <iostream>
#include <cstring>
using namespace std;

int length_arr (const char *s);
int length_ptr (const char *s);
int length_ptr_compact (const char *s);
int length_ptr_arith (const char *s);
int string_comp (char *s, char *t);
char *string_copy (char *s, char *t);

int main() {

	char text[] = "some text";
	char text1[10];

	cout << endl;
	cout << "text = " << text << endl;
	cout << "length_arr = " << length_arr(text) << endl;
	cout << "length_ptr = " << length_ptr(text) << endl;
	cout << "length_ptr_compact = " << length_ptr_compact(text) << endl;
	cout << "length_ptr_arith = " << length_ptr_arith(text) << endl;
	cout << "strlen (system library) = " << strlen(text) << endl;
	cout << "strlen(text+2) = " << strlen(text+2) << endl;
	cout << endl;

	string_copy(text1, text);
	cout << "string_copy(text1, text)\n";
	cout << "text1 = " << text1;
	cout << endl;
	cout << endl;

	text1[0] = '\0';
	cout << "text1 = " << text1 << endl;
	strcpy(text1, text);
	cout << "strcpy(text1, text) - system library \n";
	cout << "text1 = " << text1 << endl;
	cout << endl;

	text1[0] = '\0';
	int n_chars = 4;
	strncpy(text1, text, n_chars);
	text1[n_chars] = '\0';	//	strncpy does not produce null byte
	cout << "strncpy(text1, text, " << n_chars << ") - system library \n";
	cout << "text1 = " << text1 << endl;
	cout << endl;

	char *td = strdup(text);
	cout << "strdup (text) - system library \n";
	cout << "td = " << td << endl;
	cout << endl;
	cout << "text = " << text << endl;
	cout << "td   = " << td << endl;
	cout << "string_comp(text, td) = " << string_comp(text, td) << endl;
	cout << "strcmp(text, td) = " << strcmp(text, td) << endl;
	cout << endl;
	free(td);

	strcpy (text1, text);
	text1[4] = '_';
	cout << "text  = " << text << endl;
	cout << "text1 = " << text1 << endl;
	cout << "string_comp(text, text1) = " << string_comp(text, text1) << endl;
	cout << "strcmp(text, text1) = " << strcmp(text, text1) << endl;

	return EXIT_SUCCESS;
}

int length_arr(const char *s) {
	int n;
	for (n = 0; s[n] != '\0'; n++);
	return (n);
}

int length_ptr(const char *s) {
	int n;
	for (n = 0; *s != '\0'; s++, n++);
	return (n);
}

int length_ptr_compact(const char *s) {
	int n=0;
	while (*s++) n++;
	return (n);
}

int length_ptr_arith(const char *s) {
	const char *p = s;
	while (*p) p++;
	return (int)(p-s);
}

char *string_copy(char *s, char *t) {
	char *pocz = s;
	while ((*s++ = *t++));
	return pocz;
}

int string_comp(char *s, char *t) {
	for ( ;*s == *t; s++, t++)
		if (*s == '\0') return 0;
	return *s - *t;
}

